********************************************************************************
*																			   *
*           Do Psychosocial Stimulation, Parental Distress and 				   *
*			Early Childhood Education Enrollment Show Different 			   *
*			Associations with Early Childhood Development Outcomes 			   *
*			for Boys and Girls? Findings from a Phone Survey  				   *
*			in Pakistan  													   *
*																			   *
*     Stata .do file 2: Multiple imputation of missing data				       *
*																			   *
********************************************************************************

************
* Multiple imputation using chained equations  
************

* For younger cohort (0-35 months)
	use "$cleandata/ECE Survey Data Instalment 6_cleaned data.dta", clear
	
	keep if age_cat==0 

	mi set wide 
	mi register imputed credi_z distsum_z
	mi register regular ed_cat_mat rural psych_stim_z q3_a7 q1_a2 q2a8 dem4 ///
	c_age dem3 children ed_cat_pat

	mi impute chained (pmm, knn(10)) credi_z distsum_z = ed_cat_mat rural ///
	psych_stim_z q3_a7 q1_a2 q2a8 dem4 c_age dem3 children ed_cat_pat [pweight=Weight], ///
	add(30) rseed(1234) by(c_female) burnin(100)

	mi svyset [pweight=Weight]

	save "$cleandata/ECE Survey Data Instalment 6_cleaned data_mi_0-35m.dta", replace

* For older cohort (36-72 months)

	use "$cleandata/ECE Survey Data Instalment 6_cleaned data.dta", clear

	keep if age_cat==1
	
	mi set wide 
	mi register imputed schoolreadiness_z distsum_z q2a8
	mi register regular ece ed_cat_mat rural psych_stim_z q3_a7 q1_a2 dem4 c_age dem3 ///
			children ed_cat_pat

	mi impute chained (pmm, knn(10)) schoolreadiness_z distsum_z q2a8 = ece ed_cat_mat ///
	rural psych_stim_z q3_a7 q1_a2 	dem4 c_age dem3 children ed_cat_pat [pweight=Weight], ///
	add(30) rseed(1234) by(c_female) burnin(100)

	mi svyset [pweight=Weight]
	
	save "$cleandata/ECE Survey Data Instalment 6_cleaned data_mi_36-72m.dta", replace

